/**
 ******************************************************************************
 * @file    custom_mems_conf.h
 * @author  MEMS Application Team
 * @brief   This file contains definitions of the MEMS components bus interfaces for custom boards
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __CUSTOM_MEMS_CONF_H__
#define __CUSTOM_MEMS_CONF_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32l4xx_hal.h"
#include "steval_mksbox1v1_bus.h"
#include "steval_mksbox1v1_errno.h"

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */

#define USE_CUSTOM_ENV_SENSOR_HTS221_0            1U

#define USE_CUSTOM_ENV_SENSOR_LPS22HH_0           1U

#define CUSTOM_HTS221_0_I2C_Init BSP_I2C1_Init
#define CUSTOM_HTS221_0_I2C_DeInit BSP_I2C1_DeInit
#define CUSTOM_HTS221_0_I2C_ReadReg BSP_I2C1_ReadReg
#define CUSTOM_HTS221_0_I2C_WriteReg BSP_I2C1_WriteReg

#define CUSTOM_LPS22HH_0_I2C_Init BSP_I2C1_Init
#define CUSTOM_LPS22HH_0_I2C_DeInit BSP_I2C1_DeInit
#define CUSTOM_LPS22HH_0_I2C_ReadReg BSP_I2C1_ReadReg
#define CUSTOM_LPS22HH_0_I2C_WriteReg BSP_I2C1_WriteReg

#ifdef __cplusplus
}
#endif

#endif /* __CUSTOM_MEMS_CONF_H__*/

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
